## libpg-query 13

=== Makefile ===
root_dir := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
word-dot = $(word $2,$(subst ., ,$1))

TARGET = pg_query
ARLIB = lib$(TARGET).a
SOLIB = lib$(TARGET).so
PGDIR = $(root_dir)/tmp/postgres
PGDIRBZ2 = $(root_dir)/tmp/postgres.tar.bz2

PG_VERSION = 13.3
PG_VERSION_MAJOR = $(call word-dot,$(PG_VERSION),1)
PROTOC_VERSION = 3.14.0

VERSION = 2.1.1
VERSION_MAJOR = $(call word-dot,$(VERSION),1)
VERSION_MINOR = $(call word-dot,$(VERSION),2)
VERSION_PATCH = $(call word-dot,$(VERSION),3)

SONAME = $(SOLIB).$(shell printf '%02d%02d' $(PG_VERSION_MAJOR) $(VERSION_MAJOR)).$(VERSION_MINOR)
SOLIBVER = $(SONAME).$(VERSION_PATCH)

SRC_FILES := $(wildcard src/*.c src/postgres/*.c) vendor/protobuf-c/protobuf-c.c vendor/xxhash/xxhash.c protobuf/pg_query.pb-c.c
NOT_OBJ_FILES := src/pg_query_enum_defs.o src/pg_query_fingerprint_defs.o src/pg_query_fingerprint_conds.o src/pg_query_outfuncs_defs.o src/pg_query_outfuncs_conds.o src/pg_query_readfuncs_defs.o src/pg_query_readfuncs_conds.o src/postgres/guc-file.o src/postgres/scan.o src/pg_query_json_helper.o
OBJ_FILES := $(filter-out $(NOT_OBJ_FILES), $(SRC_FILES:.c=.o))

override CFLAGS += -g -I. -I./vendor -I./src/postgres/include -Wall -Wno-unused-function -Wno-unused-value -Wno-unused-variable -fno-strict-aliasing -fwrapv -fPIC

override PG_CONFIGURE_FLAGS += -q --without-readline --without-zlib

override TEST_CFLAGS += -I. -I./vendor -g
override TEST_LDFLAGS += -pthread

CFLAGS_OPT_LEVEL = -O3
ifeq ($(DEBUG),1)
	CFLAGS_OPT_LEVEL = -O0
endif
ifeq ($(VALGRIND),1)
	CFLAGS_OPT_LEVEL = -O0
endif
override CFLAGS += $(CFLAGS_OPT_LEVEL)

ifeq ($(DEBUG),1)
	# We always add -g, so this only has to enable assertion checking
	override CFLAGS += -D USE_ASSERT_CHECKING
endif
ifeq ($(VALGRIND),1)
	override CFLAGS += -DUSE_VALGRIND
	override TEST_CFLAGS += -DUSE_VALGRIND
endif

CLEANLIBS = $(ARLIB)
CLEANOBJS = $(OBJ_FILES)
CLEANFILES = $(PGDIRBZ2)

AR = ar rs
INSTALL = install
LN_S = ln -s
RM = rm -f
ECHO = echo

VALGRIND_MEMCHECK = valgrind --leak-check=full --gen-suppressions=all \
  --suppressions=test/valgrind.supp --time-stamp=yes \
  --error-markers=VALGRINDERROR-BEGIN,VALGRINDERROR-END \
  --log-file=test/valgrind.log --trace-children=yes --show-leak-kinds=all \
  --error-exitcode=1 --errors-for-leak-kinds=all

CC ?= cc

# Experimental use of Protobuf C++ library, primarily used to validate JSON output matches Protobuf JSON mapping
CXX_SRC_FILES := src/pg_query_outfuncs_protobuf_cpp.cc protobuf/pg_query.pb.cc
ifeq ($(USE_PROTOBUF_CPP),1)
	override CXXFLAGS += `pkg-config --cflags protobuf` -I. -I./src/postgres/include -DHAVE_PTHREAD -std=c++11 -Wall -Wno-unused-function -Wno-zero-length-array -Wno-c99-extensions -fwrapv -fPIC
	ifeq ($(DEBUG),1)
		override CXXFLAGS += -O0 -g
	else
		override CXXFLAGS += -O3 -g
	endif
	override TEST_LDFLAGS += `pkg-config --libs protobuf` -lstdc++

	# Don't use regular Protobuf-C or JSON implementation (instead implement the same methods using the C++ library)
	SRC_FILES := $(filter-out src/pg_query_outfuncs_json.c src/pg_query_outfuncs_protobuf.c, $(SRC_FILES))
	OBJ_FILES := $(filter-out $(NOT_OBJ_FILES), $(SRC_FILES:.c=.o)) $(CXX_SRC_FILES:.cc=.o)
else
	# Make sure we always clean C++ object files
	CLEANOBJS += $(CXX_SRC_FILES:.cc=.o)
endif

all: examples test build

build: $(ARLIB)

build_shared: $(SOLIB)

clean:
	-@ $(RM) $(CLEANLIBS) $(CLEANOBJS) $(CLEANFILES) $(EXAMPLES) $(TESTS)
	-@ $(RM) -rf {test,examples}/*.dSYM
	-@ $(RM) -r $(PGDIR) $(PGDIRBZ2)

.PHONY: all clean build build_shared extract_source examples test install

$(PGDIR):
	curl -o $(PGDIRBZ2) https://ftp.postgresql.org/pub/source/v$(PG_VERSION)/postgresql-$(PG_VERSION).tar.bz2
	tar -xjf $(PGDIRBZ2)
	mv $(root_dir)/postgresql-$(PG_VERSION) $(PGDIR)
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/01_parser_additional_param_ref_support.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/02_parser_support_question_mark_as_param_ref.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/03_lexer_track_yyllocend.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/04_lexer_comments_as_tokens.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/05_limit_option_enum_value_default.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/06_alloc_set_delete_free_list.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/07_plpgsql_start_finish_datums.patch
	cd $(PGDIR); patch -p1 < $(root_dir)/patches/08_avoid_zero_length_delimiter_in_regression_tests.patch
	cd $(PGDIR); ./configure $(PG_CONFIGURE_FLAGS)
	cd $(PGDIR); rm src/pl/plpgsql/src/pl_gram.h
	cd $(PGDIR); make -C src/pl/plpgsql/src pl_gram.h
	cd $(PGDIR); make -C src/port pg_config_paths.h
	cd $(PGDIR); make -C src/backend generated-headers
	cd $(PGDIR); make -C src/backend parser-recursive # Triggers copying of includes to where they belong, as well as generating gram.c/scan.c

extract_source: $(PGDIR)
	-@ $(RM) -rf ./src/postgres/
	mkdir ./src/postgres
	mkdir ./src/postgres/include
	LIBCLANG=/Library/Developer/CommandLineTools/usr/lib/libclang.dylib ruby ./scripts/extract_source.rb $(PGDIR)/ ./src/postgres/
	cp $(PGDIR)/src/include/storage/dsm_impl.h ./src/postgres/include/storage
	cp $(PGDIR)/src/include/port/atomics/arch-arm.h ./src/postgres/include/port/atomics
	cp $(PGDIR)/src/include/port/atomics/arch-ppc.h ./src/postgres/include/port/atomics
	touch ./src/postgres/guc-file.c
	# This causes compatibility problems on some Linux distros, with "xlocale.h" not being available
	echo "#undef HAVE_LOCALE_T" >> ./src/postgres/include/pg_config.h
	echo "#undef LOCALE_T_IN_XLOCALE" >> ./src/postgres/include/pg_config.h
	echo "#undef WCSTOMBS_L_IN_XLOCALE" >> ./src/postgres/include/pg_config.h
	# Support 32-bit systems without reconfiguring
	echo "#undef PG_INT128_TYPE" >> ./src/postgres/include/pg_config.h
	# Support gcc earlier than 4.6.0 without reconfiguring
	echo "#undef HAVE__STATIC_ASSERT" >> ./src/postgres/include/pg_config.h
	# Avoid problems with static asserts
	echo "#undef StaticAssertDecl" >> ./src/postgres/include/c.h
	echo "#define StaticAssertDecl(condition, errmessage)" >> ./src/postgres/include/c.h
	# Avoid dependency on execinfo (requires extra library on musl-libc based systems)
	echo "#undef HAVE_EXECINFO_H" >> ./src/postgres/include/pg_config.h
	echo "#undef HAVE_BACKTRACE_SYMBOLS" >> ./src/postgres/include/pg_config.h
	# Avoid dependency on cpuid.h (only supported on x86 systems)
	echo "#undef HAVE__GET_CPUID" >> ./src/postgres/include/pg_config.h
	# Ensure we don't fail on systems that have strchrnul support (FreeBSD)
	echo "#ifdef __FreeBSD__" >> ./src/postgres/include/pg_config.h
	echo "#define HAVE_STRCHRNUL" >> ./src/postgres/include/pg_config.h
	echo "#endif" >> ./src/postgres/include/pg_config.h
	# Copy version information so its easily accessible
	sed -i "" '$(shell echo 's/\#define PG_MAJORVERSION .*/'`grep "\#define PG_MAJORVERSION " ./src/postgres/include/pg_config.h`'/')' pg_query.h
	sed -i "" '$(shell echo 's/\#define PG_VERSION .*/'`grep "\#define PG_VERSION " ./src/postgres/include/pg_config.h`'/')' pg_query.h
	sed -i "" '$(shell echo 's/\#define PG_VERSION_NUM .*/'`grep "\#define PG_VERSION_NUM " ./src/postgres/include/pg_config.h`'/')' pg_query.h
	# Copy regress SQL files so we can use them in tests
	rm -f ./test/sql/postgres_regress/*.sql
	cp $(PGDIR)/src/test/regress/sql/*.sql ./test/sql/postgres_regress/

.c.o:
	@$(ECHO) compiling $(<)
	@$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

.cc.o:
	@$(ECHO) compiling $(<)
	@$(CXX) $(CXXFLAGS) -o $@ -c $<

$(ARLIB): $(OBJ_FILES) Makefile
	@$(AR) $@ $(OBJ_FILES)

$(SOLIB): $(OBJ_FILES) Makefile
	@$(CC) $(CFLAGS) -shared -Wl,-soname,$(SONAME) $(LDFLAGS) -o $@ $(OBJ_FILES) $(LIBS)

protobuf/pg_query.pb-c.c protobuf/pg_query.pb-c.h: protobuf/pg_query.proto
ifneq ($(shell which protoc-gen-c), )
	protoc --c_out=. protobuf/pg_query.proto
else
	@echo 'Warning: protoc-gen-c not found, skipping protocol buffer regeneration'
endif

src/pg_query_protobuf.c src/pg_query_scan.c: protobuf/pg_query.pb-c.h

# Only used when USE_PROTOBUF_CPP is used (experimental for testing only)
src/pg_query_outfuncs_protobuf_cpp.cc: protobuf/pg_query.pb.cc
protobuf/pg_query.pb.cc: protobuf/pg_query.proto
ifneq ($(shell protoc --version 2>/dev/null | cut -f2 -d" "), $(PROTOC_VERSION))
	$(error "ERROR - Wrong protobuf compiler version, need $(PROTOC_VERSION)")
endif
	protoc --cpp_out=. protobuf/pg_query.proto

EXAMPLES = examples/simple examples/scan examples/normalize examples/simple_error examples/normalize_error examples/simple_plpgsql
examples: $(EXAMPLES)
	examples/simple
	examples/scan
	examples/normalize
	examples/simple_error
	examples/normalize_error
	examples/simple_plpgsql

examples/simple: examples/simple.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ -g examples/simple.c $(ARLIB) $(TEST_LDFLAGS)

examples/scan: examples/scan.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ -g examples/scan.c $(ARLIB) $(TEST_LDFLAGS)

examples/normalize: examples/normalize.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ -g examples/normalize.c $(ARLIB) $(TEST_LDFLAGS)

examples/simple_error: examples/simple_error.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ -g examples/simple_error.c $(ARLIB) $(TEST_LDFLAGS)

examples/normalize_error: examples/normalize_error.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ -g examples/normalize_error.c $(ARLIB) $(TEST_LDFLAGS)

examples/simple_plpgsql: examples/simple_plpgsql.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ -g examples/simple_plpgsql.c $(ARLIB) $(TEST_LDFLAGS)

TESTS = test/complex test/concurrency test/deparse test/fingerprint test/normalize test/parse test/parse_protobuf test/parse_plpgsql test/scan test/split
test: $(TESTS)
ifeq ($(VALGRIND),1)
	$(VALGRIND_MEMCHECK) test/complex || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/concurrency || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/deparse || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/fingerprint || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/normalize || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/parse || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/parse_protobuf || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/scan || (cat test/valgrind.log && false)
	$(VALGRIND_MEMCHECK) test/split || (cat test/valgrind.log && false)
	# Output-based tests
	$(VALGRIND_MEMCHECK) test/parse_plpgsql || (cat test/valgrind.log && false)
	diff -Naur test/plpgsql_samples.expected.json test/plpgsql_samples.actual.json
else
	test/complex
	test/concurrency
	test/deparse
	test/fingerprint
	test/normalize
	test/parse
	test/parse_protobuf
	test/scan
	test/split
	# Output-based tests
	test/parse_plpgsql
	diff -Naur test/plpgsql_samples.expected.json test/plpgsql_samples.actual.json
endif

test/complex: test/complex.c $(ARLIB)
	# We have "-Isrc/" because this test uses pg_query_fingerprint_with_opts
	$(CC) $(TEST_CFLAGS) -o $@ -Isrc/ test/complex.c $(ARLIB) $(TEST_LDFLAGS)

test/concurrency: test/concurrency.c test/parse_tests.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ test/concurrency.c $(ARLIB) $(TEST_LDFLAGS)

test/deparse: test/deparse.c test/deparse_tests.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ test/deparse.c $(ARLIB) $(TEST_LDFLAGS)

test/fingerprint: test/fingerprint.c test/fingerprint_tests.c $(ARLIB)
	# We have "-Isrc/" because this test uses pg_query_fingerprint_with_opts
	$(CC) $(TEST_CFLAGS) -o $@ -Isrc/ test/fingerprint.c $(ARLIB) $(TEST_LDFLAGS)

test/normalize: test/normalize.c test/normalize_tests.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ test/normalize.c $(ARLIB) $(TEST_LDFLAGS)

test/parse: test/parse.c test/parse_tests.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ test/parse.c $(ARLIB) $(TEST_LDFLAGS)

test/parse_plpgsql: test/parse_plpgsql.c test/parse_tests.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ test/parse_plpgsql.c $(ARLIB) $(TEST_LDFLAGS)

test/parse_protobuf: test/parse_protobuf.c test/parse_tests.c $(ARLIB)
	$(CC) $(TEST_CFLAGS) -o $@ test/parse_protobuf.c $(ARLIB) $(TEST_LDFLAGS)

## libpg-query 13-2.1.0

=== debian/changelog ===
libpg-query (13-2.1.0-2) unstable; urgency=medium

  * Include server include files for missing atomics-{ia64,hppa}.h.
  * Run less threads in parallel in tests.
  * Set team as Maintainer.

 -- Christoph Berg <myon@debian.org>  Thu, 10 Feb 2022 12:23:26 +0100

libpg-query (13-2.1.0-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Thu, 03 Feb 2022 12:50:09 +0100

=== debian/control ===
Source: libpg-query
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 postgresql-server-dev-all,
 protobuf-c-compiler,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/pganalyze/libpg_query
Vcs-Browser: https://salsa.debian.org/postgresql/libpg-query
Vcs-Git: https://salsa.debian.org/postgresql/libpg-query.git
Rules-Requires-Root: no

Package: libpg-query-dev
Section: libdevel
Architecture: any
Depends: libpg-query1302.1 (= ${binary:Version}), ${misc:Depends}
Description: C library for accessing the PostgreSQL parser outside of the server environment
 This library uses the actual PostgreSQL server source to parse SQL queries and
 return the internal PostgreSQL parse tree.

Package: libpg-query1302.1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for accessing the PostgreSQL parser outside of the server environment
 This library uses the actual PostgreSQL server source to parse SQL queries and
 return the internal PostgreSQL parse tree.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

override_dh_auto_build:
	$(MAKE) build VERBOSE=1

override_dh_auto_test:
	$(MAKE) examples test TEST_CFLAGS='$$(CPPFLAGS) $$(CFLAGS)' TEST_LDFLAGS='$$(LDFLAGS)'

%:
	dh $@

=== debian/watch ===
version=4
https://github.com/pganalyze/libpg_query/tags .*/(.*).tar.gz

## libpg-query 13-2.1.1

=== debian/changelog ===
libpg-query (13-2.1.1-1.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 10.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 09 May 2022 12:51:24 +0200

libpg-query (13-2.1.1-1) unstable; urgency=medium

  * New upstream version.
  * Install examples/*.c.

 -- Christoph Berg <myon@debian.org>  Mon, 09 May 2022 12:51:24 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 10),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0

## libpg-query 13-2.1.2

=== debian/changelog ===
libpg-query (13-2.1.2-1.pgdg18.04+1) bionic-pgdg; urgency=medium

  * Rebuild for bionic-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 11.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 29 Jun 2022 12:33:40 +0200

libpg-query (13-2.1.2-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Wed, 29 Jun 2022 12:33:40 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0

## libpg-query 15

=== Makefile ===
--- 
+++ 
@@ -3,21 +3,31 @@
 
 TARGET = pg_query
 ARLIB = lib$(TARGET).a
-SOLIB = lib$(TARGET).so
 PGDIR = $(root_dir)/tmp/postgres
 PGDIRBZ2 = $(root_dir)/tmp/postgres.tar.bz2
 
-PG_VERSION = 13.3
+PG_VERSION = 15.1
 PG_VERSION_MAJOR = $(call word-dot,$(PG_VERSION),1)
 PROTOC_VERSION = 3.14.0
 
-VERSION = 2.1.1
+VERSION = 4.2.3
 VERSION_MAJOR = $(call word-dot,$(VERSION),1)
 VERSION_MINOR = $(call word-dot,$(VERSION),2)
 VERSION_PATCH = $(call word-dot,$(VERSION),3)
 
-SONAME = $(SOLIB).$(shell printf '%02d%02d' $(PG_VERSION_MAJOR) $(VERSION_MAJOR)).$(VERSION_MINOR)
-SOLIBVER = $(SONAME).$(VERSION_PATCH)
+SO_VERSION = $(shell printf '%02d%02d' $(PG_VERSION_MAJOR) $(VERSION_MAJOR)).$(VERSION_MINOR)
+
+ifeq ($(shell uname -s), Darwin)
+	SOLIB = lib$(TARGET).dylib
+	SONAME = lib$(TARGET).$(SO_VERSION).dylib
+	SOLIBVER = lib$(TARGET).$(SO_VERSION).$(VERSION_PATCH).dylib
+	SOFLAG = -install_name
+else
+	SOLIB = lib$(TARGET).so
+	SONAME = $(SOLIB).$(SO_VERSION)
+	SOLIBVER = $(SONAME).$(VERSION_PATCH)
+	SOFLAG = -soname
+endif
 
 SRC_FILES := $(wildcard src/*.c src/postgres/*.c) vendor/protobuf-c/protobuf-c.c vendor/xxhash/xxhash.c protobuf/pg_query.pb-c.c
 NOT_OBJ_FILES := src/pg_query_enum_defs.o src/pg_query_fingerprint_defs.o src/pg_query_fingerprint_conds.o src/pg_query_outfuncs_defs.o src/pg_query_outfuncs_conds.o src/pg_query_readfuncs_defs.o src/pg_query_readfuncs_conds.o src/postgres/guc-file.o src/postgres/scan.o src/pg_query_json_helper.o
@@ -103,19 +113,45 @@
 	tar -xjf $(PGDIRBZ2)
 	mv $(root_dir)/postgresql-$(PG_VERSION) $(PGDIR)
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/01_parser_additional_param_ref_support.patch
-	cd $(PGDIR); patch -p1 < $(root_dir)/patches/02_parser_support_question_mark_as_param_ref.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/03_lexer_track_yyllocend.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/04_lexer_comments_as_tokens.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/05_limit_option_enum_value_default.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/06_alloc_set_delete_free_list.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/07_plpgsql_start_finish_datums.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/08_avoid_zero_length_delimiter_in_regression_tests.patch
+	cd $(PGDIR); patch -p1 < $(root_dir)/patches/09_allow_trailing_junk.patch
 	cd $(PGDIR); ./configure $(PG_CONFIGURE_FLAGS)
 	cd $(PGDIR); rm src/pl/plpgsql/src/pl_gram.h
 	cd $(PGDIR); make -C src/pl/plpgsql/src pl_gram.h
 	cd $(PGDIR); make -C src/port pg_config_paths.h
 	cd $(PGDIR); make -C src/backend generated-headers
 	cd $(PGDIR); make -C src/backend parser-recursive # Triggers copying of includes to where they belong, as well as generating gram.c/scan.c
+	# This causes compatibility problems on some Linux distros, with "xlocale.h" not being available
+	echo "#undef HAVE_LOCALE_T" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef LOCALE_T_IN_XLOCALE" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef WCSTOMBS_L_IN_XLOCALE" >> $(PGDIR)/src/include/pg_config.h
+	# Support 32-bit systems without reconfiguring
+	echo "#undef PG_INT128_TYPE" >> $(PGDIR)/src/include/pg_config.h
+	# Support gcc earlier than 4.6.0 without reconfiguring
+	echo "#undef HAVE__STATIC_ASSERT" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid problems with static asserts
+	echo "#undef StaticAssertDecl" >> $(PGDIR)/src/include/c.h
+	echo "#define StaticAssertDecl(condition, errmessage)" >> $(PGDIR)/src/include/c.h
+	# Avoid dependency on execinfo (requires extra library on musl-libc based systems)
+	echo "#undef HAVE_EXECINFO_H" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef HAVE_BACKTRACE_SYMBOLS" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid dependency on hardware popcount instructions (POPQNTQ) on x86
+	echo "#undef HAVE_X86_64_POPCNTQ" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid dependency on cpuid.h (only supported on x86 systems)
+	echo "#undef HAVE__GET_CPUID" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid CRC extension usage to ensure we are not architecture-dependent
+	echo "#undef USE_ARMV8_CRC32C" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef USE_SSE42_CRC32C_WITH_RUNTIME_CHECK" >> $(PGDIR)/src/include/pg_config.h
+	# Ensure we don't fail on systems that have strchrnul support (FreeBSD and NetBSD)
+	echo "#include <stdlib.h>" >>  $(PGDIR)/src/include/pg_config.h
+	echo "#if defined(__FreeBSD__) || defined(__NetBSD__) || (defined(__GLIBC__) && ((__GLIBC__ == 2 && __GLIBC_MINOR__ >= 38) || __GLIBC__ > 2))" >> $(PGDIR)/src/include/pg_config.h
+	echo "#define HAVE_STRCHRNUL" >> $(PGDIR)/src/include/pg_config.h
+	echo "#endif" >> $(PGDIR)/src/include/pg_config.h
 
 extract_source: $(PGDIR)
 	-@ $(RM) -rf ./src/postgres/
@@ -123,29 +159,10 @@
 	mkdir ./src/postgres/include
 	LIBCLANG=/Library/Developer/CommandLineTools/usr/lib/libclang.dylib ruby ./scripts/extract_source.rb $(PGDIR)/ ./src/postgres/
 	cp $(PGDIR)/src/include/storage/dsm_impl.h ./src/postgres/include/storage
+	cp $(PGDIR)/src/include/port/atomics/arch-x86.h ./src/postgres/include/port/atomics
 	cp $(PGDIR)/src/include/port/atomics/arch-arm.h ./src/postgres/include/port/atomics
 	cp $(PGDIR)/src/include/port/atomics/arch-ppc.h ./src/postgres/include/port/atomics
 	touch ./src/postgres/guc-file.c
-	# This causes compatibility problems on some Linux distros, with "xlocale.h" not being available
-	echo "#undef HAVE_LOCALE_T" >> ./src/postgres/include/pg_config.h
-	echo "#undef LOCALE_T_IN_XLOCALE" >> ./src/postgres/include/pg_config.h
-	echo "#undef WCSTOMBS_L_IN_XLOCALE" >> ./src/postgres/include/pg_config.h
-	# Support 32-bit systems without reconfiguring
-	echo "#undef PG_INT128_TYPE" >> ./src/postgres/include/pg_config.h
-	# Support gcc earlier than 4.6.0 without reconfiguring
-	echo "#undef HAVE__STATIC_ASSERT" >> ./src/postgres/include/pg_config.h
-	# Avoid problems with static asserts
-	echo "#undef StaticAssertDecl" >> ./src/postgres/include/c.h
-	echo "#define StaticAssertDecl(condition, errmessage)" >> ./src/postgres/include/c.h
-	# Avoid dependency on execinfo (requires extra library on musl-libc based systems)
-	echo "#undef HAVE_EXECINFO_H" >> ./src/postgres/include/pg_config.h
-	echo "#undef HAVE_BACKTRACE_SYMBOLS" >> ./src/postgres/include/pg_config.h
-	# Avoid dependency on cpuid.h (only supported on x86 systems)
-	echo "#undef HAVE__GET_CPUID" >> ./src/postgres/include/pg_config.h
-	# Ensure we don't fail on systems that have strchrnul support (FreeBSD)
-	echo "#ifdef __FreeBSD__" >> ./src/postgres/include/pg_config.h
-	echo "#define HAVE_STRCHRNUL" >> ./src/postgres/include/pg_config.h
-	echo "#endif" >> ./src/postgres/include/pg_config.h
 	# Copy version information so its easily accessible
 	sed -i "" '$(shell echo 's/\#define PG_MAJORVERSION .*/'`grep "\#define PG_MAJORVERSION " ./src/postgres/include/pg_config.h`'/')' pg_query.h
 	sed -i "" '$(shell echo 's/\#define PG_VERSION .*/'`grep "\#define PG_VERSION " ./src/postgres/include/pg_config.h`'/')' pg_query.h
@@ -166,7 +183,7 @@
 	@$(AR) $@ $(OBJ_FILES)
 
 $(SOLIB): $(OBJ_FILES) Makefile
-	@$(CC) $(CFLAGS) -shared -Wl,-soname,$(SONAME) $(LDFLAGS) -o $@ $(OBJ_FILES) $(LIBS)
+	@$(CC) $(CFLAGS) -shared -Wl,$(SOFLAG),$(SONAME) $(LDFLAGS) -o $@ $(OBJ_FILES) $(LIBS)
 
 protobuf/pg_query.pb-c.c protobuf/pg_query.pb-c.h: protobuf/pg_query.proto
 ifneq ($(shell which protoc-gen-c), )
@@ -250,21 +267,3 @@
 	$(CC) $(TEST_CFLAGS) -o $@ test/concurrency.c $(ARLIB) $(TEST_LDFLAGS)
 
 test/deparse: test/deparse.c test/deparse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/deparse.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/fingerprint: test/fingerprint.c test/fingerprint_tests.c $(ARLIB)
-	# We have "-Isrc/" because this test uses pg_query_fingerprint_with_opts
-	$(CC) $(TEST_CFLAGS) -o $@ -Isrc/ test/fingerprint.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/normalize: test/normalize.c test/normalize_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/normalize.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/parse: test/parse.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/parse.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/parse_plpgsql: test/parse_plpgsql.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/parse_plpgsql.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/parse_protobuf: test/parse_protobuf.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/parse_protobuf.c $(ARLIB) $(TEST_LDFLAGS)
-

## libpg-query 15-4.0.0

=== debian/changelog ===
libpg-query (15-4.0.0-2.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 02 Jan 2023 20:24:14 +0200

libpg-query (15-4.0.0-2) unstable; urgency=medium

  * Fix size of PgQueryProtobuf.len.

 -- Christoph Berg <myon@debian.org>  Mon, 02 Jan 2023 20:24:14 +0200

libpg-query (15-4.0.0-1) unstable; urgency=medium

  * New upstream version with new soname.
  * Ignore test failures on 32-bit architectures.

 -- Christoph Berg <myon@debian.org>  Fri, 16 Dec 2022 13:34:55 +0100

libpg-query (13-2.1.2-2) unstable; urgency=medium

  * src/postgres/include/storage/s_lock.h: Import RISC-V tas definition.
    (Closes: #1014082, thanks Bo YU)

 -- Christoph Berg <myon@debian.org>  Tue, 05 Jul 2022 15:30:22 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper (>= 11),
+ debhelper (>= 12),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0
@@ -17,12 +17,13 @@
 Package: libpg-query-dev
 Section: libdevel
 Architecture: any
-Depends: libpg-query1302.1 (= ${binary:Version}), ${misc:Depends}
+Depends: libpg-query1504.0 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
 Description: C library for accessing the PostgreSQL parser outside of the server environment
  This library uses the actual PostgreSQL server source to parse SQL queries and
  return the internal PostgreSQL parse tree.
 
-Package: libpg-query1302.1
+Package: libpg-query1504.0
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

## libpg-query 15-4.2.0

=== debian/changelog ===
libpg-query (15-4.2.0-1.pgdg23.04+1) lunar-pgdg; urgency=medium

  * Rebuild for lunar-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 07 Feb 2023 09:40:43 +0100

libpg-query (15-4.2.0-1) unstable; urgency=medium

  * New upstream version.
  * Pin SONAME to 1504.1 since nothing changed.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Feb 2023 09:40:43 +0100

libpg-query (15-4.1.0-1) unstable; urgency=medium

  * New upstream version with new soname.

 -- Christoph Berg <myon@debian.org>  Fri, 03 Feb 2023 09:58:59 +0100

## libpg-query 15-4.2.1

=== debian/changelog ===
libpg-query (15-4.2.1-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 20 Jun 2023 15:12:08 +0200

libpg-query (15-4.2.1-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 20 Jun 2023 15:12:08 +0200

libpg-query (15-4.2.0-1) experimental; urgency=medium

  * New upstream version.
  * Pin SONAME to 1504.1 since nothing changed.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Feb 2023 09:40:43 +0100

libpg-query (15-4.1.0-1) experimental; urgency=medium

  * New upstream version with new soname.

 -- Christoph Berg <myon@debian.org>  Fri, 03 Feb 2023 09:58:59 +0100

=== debian/control ===
--- 
+++ 
@@ -17,13 +17,13 @@
 Package: libpg-query-dev
 Section: libdevel
 Architecture: any
-Depends: libpg-query1504.0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpg-query1504.1 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: C library for accessing the PostgreSQL parser outside of the server environment
  This library uses the actual PostgreSQL server source to parse SQL queries and
  return the internal PostgreSQL parse tree.
 
-Package: libpg-query1504.0
+Package: libpg-query1504.1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

## libpg-query 15-4.2.2

=== debian/changelog ===
libpg-query (15-4.2.2-1.pgdg22.10+1) kinetic-pgdg; urgency=medium

  * Rebuild for kinetic-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 11 Jul 2023 12:15:28 +0200

libpg-query (15-4.2.2-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 11 Jul 2023 12:15:28 +0200

## libpg-query 15-4.2.3

=== debian/changelog ===
libpg-query (15-4.2.3-1) unstable; urgency=medium

  * New upstream version.
  * debian/libpg-query1504.1.symbols: Add deparseRawStmt.

 -- Christoph Berg <myon@debian.org>  Tue, 08 Aug 2023 22:20:09 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 13),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0

## libpg-query 16

=== Makefile ===
--- 
+++ 
@@ -6,11 +6,11 @@
 PGDIR = $(root_dir)/tmp/postgres
 PGDIRBZ2 = $(root_dir)/tmp/postgres.tar.bz2
 
-PG_VERSION = 15.1
+PG_VERSION = 16.1
 PG_VERSION_MAJOR = $(call word-dot,$(PG_VERSION),1)
-PROTOC_VERSION = 3.14.0
-
-VERSION = 4.2.3
+PROTOC_VERSION = 25.1
+
+VERSION = 5.0.0
 VERSION_MAJOR = $(call word-dot,$(VERSION),1)
 VERSION_MINOR = $(call word-dot,$(VERSION),2)
 VERSION_PATCH = $(call word-dot,$(VERSION),3)
@@ -30,14 +30,14 @@
 endif
 
 SRC_FILES := $(wildcard src/*.c src/postgres/*.c) vendor/protobuf-c/protobuf-c.c vendor/xxhash/xxhash.c protobuf/pg_query.pb-c.c
-NOT_OBJ_FILES := src/pg_query_enum_defs.o src/pg_query_fingerprint_defs.o src/pg_query_fingerprint_conds.o src/pg_query_outfuncs_defs.o src/pg_query_outfuncs_conds.o src/pg_query_readfuncs_defs.o src/pg_query_readfuncs_conds.o src/postgres/guc-file.o src/postgres/scan.o src/pg_query_json_helper.o
+NOT_OBJ_FILES := src/pg_query_enum_defs.o src/pg_query_fingerprint_defs.o src/pg_query_fingerprint_conds.o src/pg_query_outfuncs_defs.o src/pg_query_outfuncs_conds.o src/pg_query_readfuncs_defs.o src/pg_query_readfuncs_conds.o src/postgres/guc-file.o src/postgres/scan.o src/pg_query_json_helper.o $(patsubst %.c,%.o,$(wildcard src/postgres/src_backend_nodes_*.funcs.c))
 OBJ_FILES := $(filter-out $(NOT_OBJ_FILES), $(SRC_FILES:.c=.o))
 
 override CFLAGS += -g -I. -I./vendor -I./src/postgres/include -Wall -Wno-unused-function -Wno-unused-value -Wno-unused-variable -fno-strict-aliasing -fwrapv -fPIC
 
-override PG_CONFIGURE_FLAGS += -q --without-readline --without-zlib
-
-override TEST_CFLAGS += -I. -I./vendor -g
+override PG_CONFIGURE_FLAGS += -q --without-readline --without-zlib --without-icu
+
+override TEST_CFLAGS += -g -I. -I./vendor -Wall
 override TEST_LDFLAGS += -pthread
 
 CFLAGS_OPT_LEVEL = -O3
@@ -62,7 +62,8 @@
 CLEANOBJS = $(OBJ_FILES)
 CLEANFILES = $(PGDIRBZ2)
 
-AR = ar rs
+AR ?= ar
+AR := $(AR) rs
 INSTALL = install
 LN_S = ln -s
 RM = rm -f
@@ -72,20 +73,20 @@
   --suppressions=test/valgrind.supp --time-stamp=yes \
   --error-markers=VALGRINDERROR-BEGIN,VALGRINDERROR-END \
   --log-file=test/valgrind.log --trace-children=yes --show-leak-kinds=all \
-  --error-exitcode=1 --errors-for-leak-kinds=all
+  --error-exitcode=1 --errors-for-leak-kinds=all --num-callers=50
 
 CC ?= cc
 
 # Experimental use of Protobuf C++ library, primarily used to validate JSON output matches Protobuf JSON mapping
 CXX_SRC_FILES := src/pg_query_outfuncs_protobuf_cpp.cc protobuf/pg_query.pb.cc
 ifeq ($(USE_PROTOBUF_CPP),1)
-	override CXXFLAGS += `pkg-config --cflags protobuf` -I. -I./src/postgres/include -DHAVE_PTHREAD -std=c++11 -Wall -Wno-unused-function -Wno-zero-length-array -Wno-c99-extensions -fwrapv -fPIC
+	override CXXFLAGS += `pkg-config --cflags protobuf` -I. -I./src/postgres/include -DHAVE_PTHREAD -std=c++17 -Wall -Wno-unused-function -Wno-zero-length-array -Wno-c99-extensions -fwrapv -fPIC
 	ifeq ($(DEBUG),1)
 		override CXXFLAGS += -O0 -g
 	else
 		override CXXFLAGS += -O3 -g
 	endif
-	override TEST_LDFLAGS += `pkg-config --libs protobuf` -lstdc++
+	override TEST_LDFLAGS += `pkg-config --libs protobuf` -lstdc++ -lm
 
 	# Don't use regular Protobuf-C or JSON implementation (instead implement the same methods using the C++ library)
 	SRC_FILES := $(filter-out src/pg_query_outfuncs_json.c src/pg_query_outfuncs_protobuf.c, $(SRC_FILES))
@@ -119,7 +120,7 @@
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/06_alloc_set_delete_free_list.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/07_plpgsql_start_finish_datums.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/08_avoid_zero_length_delimiter_in_regression_tests.patch
-	cd $(PGDIR); patch -p1 < $(root_dir)/patches/09_allow_trailing_junk.patch
+	cd $(PGDIR); patch -p1 < $(root_dir)/patches/09_allow_param_junk.patch
 	cd $(PGDIR); ./configure $(PG_CONFIGURE_FLAGS)
 	cd $(PGDIR); rm src/pl/plpgsql/src/pl_gram.h
 	cd $(PGDIR); make -C src/pl/plpgsql/src pl_gram.h
@@ -229,16 +230,19 @@
 examples/simple_plpgsql: examples/simple_plpgsql.c $(ARLIB)
 	$(CC) $(TEST_CFLAGS) -o $@ -g examples/simple_plpgsql.c $(ARLIB) $(TEST_LDFLAGS)
 
-TESTS = test/complex test/concurrency test/deparse test/fingerprint test/normalize test/parse test/parse_protobuf test/parse_plpgsql test/scan test/split
+TESTS = test/complex test/concurrency test/deparse test/fingerprint test/fingerprint_opts test/normalize test/parse test/parse_opts test/parse_protobuf test/parse_protobuf_opts test/parse_plpgsql test/scan test/split
 test: $(TESTS)
 ifeq ($(VALGRIND),1)
 	$(VALGRIND_MEMCHECK) test/complex || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/concurrency || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/deparse || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/fingerprint || (cat test/valgrind.log && false)
+	$(VALGRIND_MEMCHECK) test/fingerprint_opts || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/normalize || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/parse || (cat test/valgrind.log && false)
+	$(VALGRIND_MEMCHECK) test/parse_opts || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/parse_protobuf || (cat test/valgrind.log && false)
+	$(VALGRIND_MEMCHECK) test/parse_protobuf_opts || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/scan || (cat test/valgrind.log && false)
 	$(VALGRIND_MEMCHECK) test/split || (cat test/valgrind.log && false)
 	# Output-based tests
@@ -249,21 +253,13 @@
 	test/concurrency
 	test/deparse
 	test/fingerprint
+	test/fingerprint_opts
 	test/normalize
 	test/parse
+	test/parse_opts
 	test/parse_protobuf
+	test/parse_protobuf_opts
 	test/scan
 	test/split
 	# Output-based tests
 	test/parse_plpgsql
-	diff -Naur test/plpgsql_samples.expected.json test/plpgsql_samples.actual.json
-endif
-
-test/complex: test/complex.c $(ARLIB)
-	# We have "-Isrc/" because this test uses pg_query_fingerprint_with_opts
-	$(CC) $(TEST_CFLAGS) -o $@ -Isrc/ test/complex.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/concurrency: test/concurrency.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/concurrency.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/deparse: test/deparse.c test/deparse_tests.c $(ARLIB)

## libpg-query 16-5.0.0

=== debian/changelog ===
libpg-query (16-5.0.0-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Fri, 05 Jan 2024 14:42:45 +0100

libpg-query (16-5.0.0-1) experimental; urgency=medium

  * New upstream version 16-5.0.0.
  * Bump soname to libpg-query1605.0.
  * Use correct word size on all architectures.

 -- Christoph Berg <myon@debian.org>  Fri, 05 Jan 2024 14:42:45 +0100

libpg-query (15-4.2.3-2) unstable; urgency=medium

  * libpq-query-dev: Install postgresql server headers so pglast doesn't have
    to depend on a specific postgresql-server-dev-NN version.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Nov 2023 12:18:47 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 12),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0
@@ -17,13 +17,13 @@
 Package: libpg-query-dev
 Section: libdevel
 Architecture: any
-Depends: libpg-query1504.1 (= ${binary:Version}), ${misc:Depends}
+Depends: libpg-query1605.0 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: C library for accessing the PostgreSQL parser outside of the server environment
  This library uses the actual PostgreSQL server source to parse SQL queries and
  return the internal PostgreSQL parse tree.
 
-Package: libpg-query1504.1
+Package: libpg-query1605.0
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

## libpg-query 16-5.1.0

=== debian/changelog ===
libpg-query (16-5.1.0-2.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 10 Jan 2024 15:49:27 +0100

libpg-query (16-5.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Christoph Berg <myon@debian.org>  Wed, 10 Jan 2024 15:49:27 +0100

libpg-query (16-5.1.0-1) experimental; urgency=medium

  * New upstream version 16-5.1.0.
  * Bump soname to libpg-query1605.1.
  * Re-enable tests on 32-bit.

 -- Christoph Berg <myon@debian.org>  Tue, 09 Jan 2024 15:59:28 +0100

=== debian/control ===
--- 
+++ 
@@ -17,13 +17,13 @@
 Package: libpg-query-dev
 Section: libdevel
 Architecture: any
-Depends: libpg-query1605.0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpg-query1605.1 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: C library for accessing the PostgreSQL parser outside of the server environment
  This library uses the actual PostgreSQL server source to parse SQL queries and
  return the internal PostgreSQL parse tree.
 
-Package: libpg-query1605.0
+Package: libpg-query1605.1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
